%% GRADE initialization

%% control parameters for GRADE algorithm:
% parameter controling population size = pool_rate * dim
global pool_rate
pool_rate = 10.0;
% radioactivity control the amount of new solutions created by mutation
global radioactivity 
radioactivity = 0.2;
% cross_limit control the distance of new solution from its parent created by cross operator
global cross_limit
cross_limit = 1.0;  
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display( ' ' );
display(sprintf( 'GRADE cofiguration:' ));
display(sprintf( '   pool_rate = %g', pool_rate ));
display(sprintf( '   radioactivity = %g', radioactivity ));
display(sprintf( '   cross_limit = %g', cross_limit ));
display( ' ' );

global mutation_rate_limit
mutation_rate_limit = 1.0;
global SelectedSize
SelectedSize = pool_rate*Dim;
global PoolSize
PoolSize = 2*SelectedSize;

global generation
generation = 0;

global fitness_call
fitness_call = 0;

global Force
Force = zeros(PoolSize,1);

global CH
CH = rand(PoolSize,Dim);
for i = 1:PoolSize
    for j = 1:Dim
        CH(i,j) = CH(i,j)*(Domain(j,2)-Domain(j,1))+Domain(j,1);
    end
end

global bsf
bsf = zeros(Dim,1);
global btg
btg = zeros(Dim,1);
global bsf_value
bsf_value = 999999999999 ; 
global btg_value
btg_value = 999999999999 ; 

%% EVALUATE_GENERATION 
display( sprintf( 'Fitness call    BTG value    BSF value', fitness_call, btg_value) );
for i = 1:PoolSize;
    if Return_to_domain == 1
        for k = 1:Dim 
            if CH(i,k) < Domain(k,1) CH(i,k) = Domain(k,1); end
            if CH(i,k) > Domain(k,2) CH(i,k) = Domain(k,2); end
        end
    end 

    Force(i) = F( (CH(i,:))' );
    fitness_call = fitness_call+1; 
    if Force(i) < btg_value
        btg_value = Force(i);
        btg(:)=CH(i,:);  
    end 
    
end 
if btg_value < bsf_value 
    bsf(:) = btg(:);
    bsf_value = btg_value; 
    Feval()
end 
display( sprintf( '%12d   %10g   %10g', fitness_call, btg_value, bsf_value) );

%% SELECT 
ActualSize=PoolSize;
while ActualSize > SelectedSize
    i1 = randsample(ActualSize,1); 
    i2 = randsample(ActualSize-1,1)+1; 
    if i1 == i2 i2 = i2-1; end 
    if Force(i1) < Force(i2) dead = i2;  
    else dead = i1; end
    last = ActualSize; 
    CH(dead,:) = CH(last,:); 
    Force(dead) = Force(last); 
    ActualSize = ActualSize-1; 
end

%% author: Anicka Kucerova, Czech Technical University in Prague
%% version 0.0.2
%% 6 Feb 2009